/* myMusic
 *
 * This program is distributed under the GNU General Public License, version 2.
 * A copy of this license is included with this source.
 *
 * Copyright 2004-2006, Toni Thomsson <toni@tonjac.org> 
*/
 
// Implementation of class Cmp3StreamServer

#include "mp3_stream_server.h"

// Construction
Cmp3StreamServer::Cmp3StreamServer( CzzString home )
 : CzzNTService( STREAM_SVC_NAME, STREAM_SVC_NAME
  , "", STREAM_SVC_NAME, "", STREAM_SVC_DESCRIPTION, SERVICE_AUTO_START ), m_Icecast( NULL ), m_Home( home )
{

}

// Destruction
Cmp3StreamServer::~Cmp3StreamServer()
{
	if( m_Icecast )
	{
		m_Icecast->Stop( true, 0 );
		delete m_Icecast;
	}
}

void Cmp3StreamServer::OnStart( int argc, char** argv )
{

	DWORD wait;
	
	Init();

	m_Icecast = new Cmp3Icecast( m_Home );
	m_Icecast->Run();
		
	// Default impl. does nothing just loops and waits for stop signal
	while( 1 )
	{
		wait = WaitForSingleObject( m_StopEvent, INFINITE );
		if( wait == WAIT_OBJECT_0 )
			break;

	}
	
	Exit();
}


