/* myMusic
 *
 * This program is distributed under the GNU General Public License, version 2.
 * A copy of this license is included with this source.
 *
 * Copyright 2004-2006, Toni Thomsson <toni@tonjac.org> 
*/
 
// Implementation of class Cmp3AudioSource

#include "mp3_audio_source.h"

// Construction
Cmp3AudioSource::Cmp3AudioSource( void )
 : CzzNTService( SOURCE_SVC_NAME, SOURCE_SVC_NAME
  , "", SOURCE_SVC_NAME, STREAM_SVC_NAME, SOURCE_SVC_DESCRIPTION, SERVICE_AUTO_START ), m_Streamers(), m_PlaylistHandler(NULL)
{

}

// Destruction
Cmp3AudioSource::~Cmp3AudioSource()
{
	
}

// Starts the jobs
void Cmp3AudioSource::StartJobs( void )
{
	Cmp3Streamer* streamer = NULL;
	m_PlaylistHandler = new Cmp3PlayListHandler();
	m_PlaylistHandler->Run();

	map<CzzString, Cmp3PlayList* >::iterator i;

    for( i = m_PlaylistHandler->getPlayLists()->begin(); i != m_PlaylistHandler->getPlayLists()->end(); i++ )
    {
        streamer = new Cmp3Streamer( m_PlaylistHandler, i->first );
		m_Streamers[ i->first ] = streamer;
		streamer->Run();
    }
}

void Cmp3AudioSource::OnStop( void )
{
	if( m_PlaylistHandler )
	{
		m_PlaylistHandler->Stop( true, 0 );
		delete m_PlaylistHandler;
	}

	map<CzzString, Cmp3Streamer* >::iterator i;

	for( i = m_Streamers.begin(); i != m_Streamers.end(); i++ )
    {
		i->second->Stop( false, 0 );

		m_Log.Print( _INFOPARAMS, "Waiting for stream thread to finnish..." );	

		while( i->second->Running() )
            Sleep(10);

		m_Log.Print( _INFOPARAMS, "...stream thread done" );	

		delete i->second;
	}

	m_Streamers.clear();

	CzzNTService::OnStop();
}

void Cmp3AudioSource::OnStart( int argc, char** argv )
{

	DWORD wait;
	
	Init();

	// Start worker threads
	StartJobs();
	
	// Default impl. does nothing just loops and waits for stop signal
	while( 1 )
	{
		wait = WaitForSingleObject( m_StopEvent, INFINITE );
		if( wait == WAIT_OBJECT_0 )
			break;

	}
	
	Exit();
}


