/* myMusic
 *
 * This program is distributed under the GNU General Public License, version 2.
 * A copy of this license is included with this source.
 *
 * Copyright 2004-2006, Toni Thomsson <toni@tonjac.org> 
*/
 
// Implementation of class Cmp3SourceConfig

#include <mp3_source_config.h>
#include <zz_log_exception.h>

// Construction
Cmp3SourceConfig::Cmp3SourceConfig( void )
{
	

}

// Destruction
Cmp3SourceConfig::~Cmp3SourceConfig()
{

}

CzzString Cmp3SourceConfig::getDataDir( void )
{
	CzzString result = getEntry( "lib_dir" );

	if( result[ result.size()-1 ] == '\\' )
		result = result.substr( 0, result.size()-1 );

	return result;
}

CzzString Cmp3SourceConfig::getM3uDir( void )
{
	CzzString result = getEntry( "m3u_dir" );

	if( result[ result.size()-1 ] == '\\' )
		result = result.substr( 0, result.size()-1 );

	return result;
}

CzzString Cmp3SourceConfig::getPauseSong( void )
{
	return getEntry( "pause_song" );
}

CzzString Cmp3SourceConfig::getPauseMessage( void )
{
	return getEntry( "pause_message" );
}


CzzString Cmp3SourceConfig::getSourceUser( void )
{
	return getEntry( "source_user" );
}

CzzString Cmp3SourceConfig::getSourcePwd( void )
{
	return getEntry( "source_password" );
}

CzzString Cmp3SourceConfig::getSourceName( void )
{
	return getEntry( "source_name" );
}

CzzString Cmp3SourceConfig::getSourceBitrate( void )
{
	return getEntry( "source_bitrate" );
}

CzzString Cmp3SourceConfig::getSourceMount( void )
{
	return getEntry( "mount" );
}

CzzString Cmp3SourceConfig::getWebserverPort( void )
{
	return getEntry( "http_listen_port" );
}

CzzString Cmp3SourceConfig::getCGIUrl( void )
{
	return getEntry( "cgi" );
}

CzzString Cmp3SourceConfig::getAdminUser( void )
{
	return getEntry( "admin_user" );
}

CzzString Cmp3SourceConfig::getAdminPwd( void )
{
	return getEntry( "admin_password" );
}

CzzString Cmp3SourceConfig::getServerPort( void )
{
	return getEntry( "server_port" );
}

CzzString Cmp3SourceConfig::getServerHost( void )
{
	return getEntry( "server_hostname" );
}

CzzString Cmp3SourceConfig::getServerProtocol( void )
{
	return getEntry( "server_protocol" );
}

CzzString Cmp3SourceConfig::getServerMetadataUrl( void )
{
	return getEntry( "meta_info_url" );
}

CzzString Cmp3SourceConfig::getEntry( const CzzString& entry )
{
	char var[ 256 ];

	if( !GetPrivateProfileString( Cmp3SourceConfig::appName().c_str(), entry.c_str(), "", var, sizeof( var ), CzzString::Format( ".\\%s.ini", Cmp3SourceConfig::appName().c_str() ).c_str() ) )
		throw CzzLogException( _LAF, 4711, CzzString::Format( "Kunde inte lsa configuration [%s] - '%s' frn '%s'", Cmp3SourceConfig::appName().c_str(), entry.c_str(), CzzString::Format( ".\\%s.ini", Cmp3SourceConfig::appName().c_str() ).c_str() ) );
		
	return var;
}

void Cmp3SourceConfig::setEntry( const CzzString& entry, const CzzString& value )
{
	if( !WritePrivateProfileString( Cmp3SourceConfig::appName().c_str(), entry.c_str(), value.c_str(), CzzString::Format( ".\\%s.ini", Cmp3SourceConfig::appName().c_str() ).c_str() ) )
		throw CzzLogException( _LAF, 4711, CzzString::Format( "Kunde inte skriva configuration [%s] - '%s' till '%s'", Cmp3SourceConfig::appName().c_str(), entry.c_str(), CzzString::Format( ".\\%s.ini", Cmp3SourceConfig::appName().c_str() ).c_str() ) );
}

CzzString Cmp3SourceConfig::appName( void )
{
	return "mp3_source";
}
