/* myMusic
 *
 * This program is distributed under the GNU General Public License, version 2.
 * A copy of this license is included with this source.
 *
 * Copyright 2004-2006, Toni Thomsson <toni@tonjac.org> 
*/

// Implementation of class Cmp3HtmlFile

#include "mp3_html_file.h"
#include "mp3_config.h"
#include <zz_log_exception.h>
#include <stdio.h>

// Construction
Cmp3HtmlFile::Cmp3HtmlFile( const char* file )
 : m_File(), m_Buffer()
{
	Cmp3Config cfg;
	m_File = CzzString::Format( "%s\\%s", Cmp3Config::getLang().c_str(), file );

	readFile();
}

// Destruction
Cmp3HtmlFile::~Cmp3HtmlFile()
{

}

// Print file
void Cmp3HtmlFile::print( int d, ... )
{

	char* s = NULL;
	va_list argptr;
   		
	// Point to first argument
	va_start( argptr, d );

	s = new char[ m_Buffer.size() + 10240 ];

	// Create and print output
	vsprintf( s, m_Buffer.c_str(), argptr );
	printf( "%s", s );

	// Clean up !
	va_end( argptr ); 
	delete [] s;
}

// Read file
void Cmp3HtmlFile::readFile( void )
{

	m_Buffer = "";
	char buff[1024];
	FILE* fp = NULL;

	if( fp = fopen( m_File.c_str(), "r" ) )
	{
		while ( fgets( buff, 1024, fp ) )
		{
			//buff[ strlen( buff ) - 1 ] = 0;
			m_Buffer += buff;

		}

		fclose( fp );
	}
	else
		throw CzzLogException( _LAF, 4711, CzzString::Format( "Can not open '%s'", m_File.c_str()) );
}

// Create a HTML-encoded string for filling a combobox with items
CzzString Cmp3HtmlFile::createComboBoxItemString( Cmp3ItemList& list )
{
	CzzString result;

	if( list.size() > 0 )
		result += CzzString::Format( "<OPTION SELECTED>%s</OPTION>\n", list[ 0 ].c_str() );

	for( short i = 1; i < list.size(); i++ )
		result += CzzString::Format( "\t<OPTION>%s</OPTION>\n", list[ i ].c_str() );

	return result;
}


