/* myMusic
 *
 * This program is distributed under the GNU General Public License, version 2.
 * A copy of this license is included with this source.
 *
 * Copyright 2004-2006, Toni Thomsson <toni@tonjac.org> 
*/

// Implementation of class Cmp3InfoRender

#include "mp3_info_render.h"
#include "mp3_general_data.h"
#include "mp3_config.h"
#include "mp3_svc.h"
#include "mp3_info_data.h"
#include "mp3_version_list_data.h"

// Construction
Cmp3InfoRender::Cmp3InfoRender( void* session, CzzParameterMap* cgi )
: CzzOutputRender( CzzString::Format( ".\\%s\\%s\\renderInfo.html", Cmp3Config::getLang().c_str(), Cmp3Config::getSkin().c_str() ) , session, cgi )
{

	CzzString back_url = CzzString::Format( "%s/mp3_gui.exe?svc=%d&anchor=A", 
											Cmp3Config::getCGIDir().c_str(), 
											MP3_SVC_LIST_ARTISTS );

	this->addFieldSvc( new Cmp3GeneralData( back_url, "myMusic", 
		CzzString::Format( "%s", "Info" )));

	this->addFieldSvc( new Cmp3InfoData( ) );

	this->addListSvc( MP3_FLD_TABLE, new Cmp3VersionListData( ) );

}

// Destruction
Cmp3InfoRender::~Cmp3InfoRender()
{

}

