/* myMusic
 *
 * This program is distributed under the GNU General Public License, version 2.
 * A copy of this license is included with this source.
 *
 * Copyright 2004-2006, Toni Thomsson <toni@tonjac.org> 
*/

// Implementation of class Cmp3MyRadioChannelsData

#include "mp3_http_requester.h"
#include "mp3_myradio_channels_data.h"
#include "mp3_config.h"
#include "mp3_svc.h"

// Construction
Cmp3MyRadioChannelsData::Cmp3MyRadioChannelsData( void )
: CzzDataService( "listMyRadioData" )
{

}

// Destruction
Cmp3MyRadioChannelsData::~Cmp3MyRadioChannelsData()
{

}

CzzDataServiceReply* Cmp3MyRadioChannelsData::execute( void* session, CzzParameterMap* req )
{
	CzzDataService::execute( session, req );

	CzzDataServiceReply* reply = new CzzDataServiceReply();
	
	reply->addFieldName( "channel" );
	reply->addFieldName( "PlayChannel" );



    int size = 10240;
	char* sections_str = new char[size];
    CzzString tmp;
    memset( sections_str, 0, size );
    CzzString file = ".\\mp3.ini";

    int r = GetPrivateProfileSection( "admin", sections_str, size, file.c_str() );
    int i = 1;

    while( r == sizeof(sections_str) - 2 )
    {
        i++;
        delete [] sections_str;
        char* sections_str = new char[size*i];
        memset( sections_str, 0, size );
        r = GetPrivateProfileSection( "admin", sections_str, size*i, file.c_str() );
    }

    if( r )
    {
		char* p = sections_str;

		for( i=0; i <= r; i++ )
		{
			if( sections_str[i] == 0 )
			{
				tmp = p;
            
				if( tmp.size() )
				{
					int pos = tmp.find( "=" );
					CzzString usr = tmp.substr( 0, pos );
                    reply->addFieldValue( usr );
                    reply->addFieldValue( CzzString::Format( "%s/mp3_playlist.exe?svc=6&usr=%s", Cmp3Config::getCGIDir().c_str(), usr.c_str() ) );
				}

				p = sections_str + i + 1;
			}
		}
	}

    delete [] sections_str;

    return reply;
}

int Cmp3MyRadioChannelsData::size()
{
    return sizeof(Cmp3MyRadioChannelsData);
}