/* myMusic
 *
 * This program is distributed under the GNU General Public License, version 2.
 * A copy of this license is included with this source.
 *
 * Copyright 2004-2006, Toni Thomsson <toni@tonjac.org> 
*/

#ifndef mp3_thread_safe_config_h
#define mp3_thread_safe_config_h

#include <zz_string.h>
#include <zz_win_threadmutex.h>
#include <map>

typedef map<CzzString, CzzString > Cmp3Block;

/**
	Thread safe configuration reader

	Toni Thomsson, toni@tonjac.org
*/
class Cmp3ThreadSafeConfig
{
public:

	//* Construction
	Cmp3ThreadSafeConfig( const CzzString& name );
	virtual ~Cmp3ThreadSafeConfig();

	CzzString getEntry( const CzzString& block, const CzzString& entry );

protected:
private:

	CzzString m_File;
	map<CzzString, Cmp3Block* > m_BlockList;
	static CzzWinThreadMutex m_Mutex;
};

#endif // mp3_thread_safe_config_h