/* libzzutil
 *
 * This program is distributed under the GNU General Public License, version 2.
 * A copy of this license is included with this source.
 *
 * Copyright 2000-2006, Toni Thomsson <toni@tonjac.org> 
*/

#ifndef zz_zip_h
#define zz_zip_h

#pragma warning(disable:4786)

extern "C"
{
	#include <structs.h>
}

#include <windows.h>
#include <direct.h>
#include <map>
#include <string>
#include <zz_file.h>
#include <zz_exception.h>
#include <zz_string.h>

using namespace std;

extern "C"
{

/** Used internally */
typedef int ( __stdcall FUNC_ZPINIT )( ZIPUSERFUNCTIONS* );

/** Used internally */
typedef BOOL ( __stdcall FUNC_ZPSETOPTIONS )( ZPOPT );

/** Used internally */
typedef int ( __stdcall FUNC_ZPARCHIVE )( ZCL );

}

/**
    Zip archive

    @author Toni Thomsson, toni@tonjac.org
*/
class ZZ_API CzzZip : public CzzFile
{
public:

	/**
        Create a zip archive
        @param archive  Path to archive
    */
	CzzZip( const char* archive );

	virtual ~CzzZip();

	/**
        Add a file to the zip archive
        @param file  Path to file
    */
	void AddFile( const char* file );

	/**
        Compress archive
    */
	void Compress( void );

private:

	void InitOptions( void );

	map<int, string > m_Files;
	HINSTANCE m_hDLL;
	string m_Name;
	ZPOPT m_Options;
	ZCL m_Archive;
	ZIPUSERFUNCTIONS m_UserFuncs;
	FUNC_ZPSETOPTIONS* m_pfZpSetOptions;
	FUNC_ZPINIT* m_pfZpInit;
	FUNC_ZPARCHIVE* m_pfZpArchive;
};

#endif // zz_zip_h

